# any() function is python >= 2.5
try:
  any = any
except NameError:
  def any(iterable):
    for element in iterable:
        if element:
            return True
    return False
    
# all() function is python >= 2.5
try:
  all = all
except NameError:
  def all(iterable):
    for element in iterable:
        if not element:
            return False
    return True

# next() function is python >= 2.6
try:
    next = next
except NameError:
    _default_next = object()
    def next(iterator, default=_default_next):
        try:
            return iterator.next()
        except StopIteration:
            if default is not _default_next:
                return default
            raise
