#uses "CtrlPv2Admin"
#uses "pa.ctl"
#uses "pmon.ctl"
//#uses "fwInstallation.ctl"

#uses "PVSSBootstrapper/PVSSBootstrapper_log.ctl"
#uses "PVSSBootstrapper/PVSSBootstrapper_config.ctl"
#uses "PVSSBootstrapper/PVSSBootstrapper_execution.ctl"
#uses "PVSSBootstrapper/PVSSBootstrapper_functions.ctl"
#uses "PVSSBootstrapper/PVSSBootstrapper_lib.ctl"
#uses "PVSSBootstrapper/PVSSBootstrapper_pmon.ctl"
//#uses "PVSSBootstrapper/PVSSBootstrapper_DB.ctl"

bool g_PVSSBootstrapperUseDB = false;

// For pa.ctl/pmon.ctl
int gTcpFileDescriptor = -1;
int gTcpFileDescriptor2 = -1;
string gTcpHostName = "";
int gTcpPortNumber = -1;
string gTcpFifo = "";

void main() {
  int err;
  mapping options;
  
  err = PVSSBootstrapper_getConfig(options);
  if(err < 0) {
    writeReturnInfo(err);
    return;
  }
  
  if(options["debug"])
    DebugN(options);
  
  err = PVSSBootstrapper_execute(options);
  if(err < 0) {
    writeReturnInfo(err);
    return;
  }
  
  PVSSBootstrapper_log("INFO", "Finished!");
  
  writeReturnInfo(0);
}

void writeReturnInfo(int errCode) {
  int err;
  
  err = PVSSBootstrapper_setStringInConfigFile("PVSSBootstrapper", "errCode", errCode);
  if(err < 0)
    return;
  
  err = PVSSBootstrapper_setStringInConfigFile("PVSSBootstrapper", "errMsg", PVSSBootstrapper_getLastErrorMessage());
  if(err < 0)
    return;
  
  string warningMsg = PVSSBootstrapper_getLastWarningMessage();
  if(warningMsg != "") {
    err = PVSSBootstrapper_setStringInConfigFile("PVSSBootstrapper", "warningMsg", warningMsg);
    if(err < 0)
      return;
  }
  
  string returnData = PVSSBootstrapper_getReturnData();
  if(returnData != "") {
    err = PVSSBootstrapper_setStringInConfigFile("PVSSBootstrapper", "returnData", returnData);
    if(err < 0)
      return;
  }
}
