string lastWarningMessage="";
string lastErrorMessage="";
string returnData="";

int PVSSBootstrapper_log(string logLevel, string logText) {
  int err = 0;
  
  if(logLevel == "ERROR") {
    lastErrorMessage = logText;
    _PVSSBootstrapper_throw(logText, logLevel);
  }else if (logLevel == "WARNING")
    lastWarningMessage = logText;
    
  if(g_PVSSBootstrapperUseDB && (g_agentRequestId != -1))
    err = _PVSSBootstrapperDB_log(g_agentRequestId, logLevel, logText);
  
  DebugN(logLevel + ": " + logText);

  return err;  
}

// Copy/Paste from fwInstallation_throw.
// Did it because there is use case where we don't use fwInstallation.
void _PVSSBootstrapper_throw(string msg, string severity = "ERROR", int code = 1) {
  int prio = PRIO_WARNING; 
  int type = ERR_CONTROL;
  
  switch(strtoupper(severity))
  {
    case "INFO": prio = PRIO_INFO; code =10; break;
    case "WARNING": prio = PRIO_WARNING; break;
    case "ERROR": prio = PRIO_SEVERE; break;
  }
  
  errClass err = makeError("fwInstallation", prio, type, code, msg);
  throwError(err);
  
  return;
}

string PVSSBootstrapper_getLastWarningMessage() {
  return lastWarningMessage;
}

string PVSSBootstrapper_getLastErrorMessage() {
  return lastErrorMessage;
}

void PVSSBootstrapper_setReturnData(string data) {
  returnData = data;
}

string PVSSBootstrapper_getReturnData() {
  return returnData;
}
