#!/bin/bash

if [ -z $1 ]; then
  echo "Usage: $0 ABSOLUTE_PATH_TO_PVSS_PROJECT"
  exit
fi

cd ../../.. # Important to be in the directory of the bootstrapper.

# With the Python script (Windows/Linux)
./PVSSBootstrapper.py startProject "$1"
# Available options for startProject:
# --started-with-manager "MANAGER OPTIONS"
#                       Tell which manager should be running to determine the
#                       project is running (default: PVSS00ui -m gedi).
#                       Flexible check on the manager options.
# --no-console          Do not open a console when starting a project
#                       (default: False).
# --no-log-viewer       Open a log viewer when starting a project (default:
#                       False).
#
# General options:
#  -h, --help            show this help message and exit
#  --pvss VERSION        Use a specific PVSS version (default: the latest
#                        available).
#  -g, --debug           Activate debug flag (default: false).
#
# Options related to PVSS components:
#  --fwInstallation-zip-path ZIP_FILE
#                        If set, install the fwInstallation tool in the created
#                        project from the givein ZIP file.
#  --component-install-dir PATH
#                        Directory in which the installation tool will install
#                        the components.


# With the old bash script for Linux:
#
# --start-project PATH               Give the path of the project to start. If it is not a PVSS registered project it will be automatically registered. Stop all running project before.
# --started-with-manager PVSS00...   Tell which manager should be running to determine the project is running (eg. PVSS00ui)
# --started-with-options "OPTION"    Options of the manager that help filtering out the wrong managers (eg. "-m gedi").
# --open-console BOOL                Open a console when starting a project (a PVSS bug on Linux makes it not working...).
# --open-log-viewer BOOL             Open a log viewer when starting a project.
#./PVSSBootstrapperLinux.sh --start-project "$1" --started-with-manager PVSS00ui --started-with-options "-m gedi" --open-console true --open-log-viewer true
