#!/bin/bash

if [ -z $1 ] || [ -z $2 ]; then
  echo "Usage: $0 ABSOLUTE_INSTALL_DIR PROJECT_NAME"
  exit
fi

cd ../../.. # Important to be in the directory of the bootstrapper.

# With the Python script (Windows/Linux)
./PVSSBootstrapper.py createProject --delete-if-exists "$1" "$2"
# Available options for startProject:
#  --system-number N   Set the system number of the project to create (default:
#                      1).
#  --system-name NAME  Set the system name of the project to create (default:
#                      "dist_" + systemNumber).
#  --delete-if-exists  If a similar project exists it will be deleted first
#                      (default: false).
#  --pmon-port N       Set the port for pmon of the project to create (default:
#                      0).
#  --data-port N       Set the port for data manager of the project to create
#                      (default: 0).
#  --event-port N      Set the port for event manager of the project to create
#                      (default: 0).
#  --dist-port N       Set the port for distributed manager of the project to
#                      create (default: 0).
#  --no-console        Do not open a console when starting a project (default:
#                      False).
#  --no-log-viewer     Open a log viewer when starting a project (default:
#                      False).
#
# General options:
#  -h, --help            show this help message and exit
#  --pvss VERSION        Use a specific PVSS version (default: the latest
#                        available).
#  -g, --debug           Activate debug flag (default: false).
#
# Options related to PVSS components:
#  --fwInstallation-zip-path ZIP_FILE
#                        If set, install the fwInstallation tool in the created
#                        project from the givein ZIP file.
#  --component-install-dir PATH
#                        Directory in which the installation tool will install
#                        the components.

# With the old bash script for Linux:
#
# --project-install PATH               Create a project in the given directory.
# --project-name NAME                  Give the name of the project to create.
# --project-delete-if-exists BOOL      If the project already exists, delete it.
#./PVSSBootstrapperLinux.sh --project-install "$1" --project-name "$2" --project-delete-if-exists true
