#!/bin/bash

if [ -z $1 ] || [ -z $2 ]; then
  echo "Usage: $0 ABSOLUTE_INSTALL_DIR PROJECT_NAME"
  exit
fi

# Because the Python/Bash scripts are not finished yet, for the moment the
# only way to install components is to bake your own config file.

configFile="createProjectInstallComponents.config"

FW_INST_TOOL_ZIP="/afs/cern.ch/project/itcobe/Delivery/Products/Framework/Software/OfficialVersions/fwInstallation5.0.3.zip"
JCOP_FW_SOURCE="/afs/cern.ch/project/itcobe/Delivery/Products/Framework/Software/OfficialVersions/framework4.2.0/PVSS"

cp "$configFile.model" "$configFile"

sed -i "s,#INSTALL_DIR#,$1," "$configFile"
sed -i "s,#PROJECT_NAME#,$2," "$configFile"
sed -i "s,#FWINST_ZIP_PATH#,$FW_INST_TOOL_ZIP," "$configFile"
sed -i "s,#COMP_SOURCE_1#,$JCOP_FW_SOURCE," "$configFile"
#sed -i "s,#COMP_SOURCE_2#,...," "$configFile" # To use this one, edit the createProjectInstallComponents.config.model file and uncomment the corresponding line.

configFile=`readlink -f $configFile`

cd ../../.. # Important to be in the directory of the bootstrapper.

# With the Python script (Windows/Linux)
./PVSSBootstrapper.py configFile "$configFile"

# With the old bash script for Linux:
#./PVSSBootstrapperLinux.sh -c "$configFile"
