import os
import zipfile
from PVSSBootstrapper import PVSSBootstrapper
from PVSSBootstrapperTests import PBSTestCase

# unittest with extended functionalities is from Python >= 2.7
# Load compatible package (install it before) unittest2
try:
  import unittest2 as unittest
except ImportError:
  import unittest

projectName = "PBSTest_deployZip"

class DeployZipTests(PBSTestCase):

  @classmethod
  def setUpClass(cls):
    PBSTestCase.setUpClass()
    PVSSBootstrapper.stopAllProjects()
    
    cls.fwInstallation = PBSTestCase.getLatestFwInstallation()

  @classmethod
  def tearDownClass(cls):
    PBSTestCase.tearDownClass()

  def setUp(self):
    PBSTestCase.setUp(self)
    PVSSBootstrapper.createProject(self.sandbox, projectName, overwrite=True)
    
    self.projectPath = os.path.join(self.sandbox, projectName)
  
  def tearDown(self):
    PBSTestCase.tearDown(self)
    PVSSBootstrapper.deleteProject(projectName)
    
  def test_deployZip(self):
    zipFile = zipfile.ZipFile(self.fwInstallation, 'r')
    members = zipFile.namelist()
    zipFile.close()
    
    PVSSBootstrapper.deployZip(projectName, self.fwInstallation)
    
    for member in members:
      self.assertTrue(os.path.exists(os.path.join(self.projectPath, member)))
