/*
 * 
 * This library contains the constants
 * to all benchmarks
 * 
 * jean-charles.tournier@cern.ch
 * CERN - EN/ICE/SCD
 * 
 * July 9th, 2015
 * 
 */
 
 
//name of the table used for the log in the UI
//place here and not in ConstUI as it is used by Util.ctl
const string FWBM_LOG_TABLE = "LOG_TABLE";
 
//return code 
const int FWBM_PVSS_SUCCESS = 0;
const int FWBM_PVSS_ERROR = -1;
 
//DPT used by all DPs
const string FWBM_DPTYPE = "ExampleDP_Int";
const string FWBM_DPBASENAME = "fw-";
 
//log level for print message
const int FWBM_ERROR_LOG = 3; 
const int FWBM_WARNING_LOG = 2; 
const int FWBM_INFO_LOG = 1; 

//line separator between section in the report
const string FWBM_NEW_SECTION = "-------------------------------------";


//Number of round for each benchmark to have relevant statistics
const int FWBM_NUM_ROUND = 3;
const int FWBM_DELAY_ROUND = 1; //delay between the execution of two rounds

//Configurations names to set and get values
const string FWBM_CONFIG_ORIGINALVALUE = "OriginalValue";
const string FWBM_CONFIG_DRIVER_SIM = "SimulatorDriver";
const string FWBM_CONFIG_DRIVER_S7 = "SimaticS7Driver";
const string FWBM_CONFIG_DRIVER_MODBUS = "ModbusDriver";
const string FWBM_CONFIG_DRIVER_IEC = "IECDriver";
const string FWBM_CONFIG_ARCHIVE = "Archive";
const string FWBM_CONFIG_ALERTHDL = "AlertHandling";

//Device Manager Identifier
const int FWBM_MANAGERID_SIM = 1;
const int FWBM_MANAGERID_S7 = 2;
const int FWBM_MANAGERID_MODBUS= 3;
const int FWBM_MANAGERID_IEC= 4;

//Configurations Name
const dyn_string FWBM_ORIGINAL_CONFIG_NAME = makeDynString(":_original.._value");

const dyn_string FWBM_DEVICE_CONFIG_NAME = makeDynString(	":_distrib.._type",
															":_distrib.._driver",
															":_address.._type",
															":_address.._reference",
															":_address.._subindex",
															":_address.._mode",
															":_address.._datatype",
															":_address.._drv_ident",
															":_address.._active"
);

													
const dyn_string FWBM_ARCHIVE_CONFIG_NAME = makeDynString(":_archive.._type",
														":_archive.1._type",
														":_archive.1._class",
														":_archive.._archive");
														
const dyn_string FWBM_ALERTHDL_CONFIG_NAME = makeDynString(":_alert_hdl.._type",
														":_alert_hdl.1._type",
														":_alert_hdl.2._type",
														
														":_alert_hdl.1._u_limit",
														":_alert_hdl.2._l_limit",
														
														":_alert_hdl.1._u_incl",
														":_alert_hdl.1._l_incl",
														":_alert_hdl.2._u_incl",
														":_alert_hdl.2._l_incl",
														
														":_alert_hdl.1._text",
														":_alert_hdl.2._text",
														":_alert_hdl.2._class",
														":_alert_hdl.._orig_hdl",
														":_alert_hdl.._active"
);
														
const int FWBM_DEVICE_REFERENCE_POSITION = 4;	//The forth element in FWBM_DEVICE_CONFIG_NAME is the reference's name

//Configurations Value
const dyn_anytype FWBM_ORIGINAL_CONFIG_VALUE = makeDynAnytype(314);

const dyn_anytype FWBM_SIM_CONFIG_VALUE = makeDynAnytype(	DPCONFIG_DISTRIBUTION_INFO,		//:_distrib.._type = 56 -> Driver allocation									
															FWBM_MANAGERID_SIM,				//:_distrib.._driver = 1 -> Driver manager connected
															DPCONFIG_PERIPH_ADDR_MAIN,		//:_address.._type = 16 -> General peripheral address
															"SIM.",							//:_address.._reference -> Reference's name
															0,								//:_address.._subindex
															DPATTR_ADDR_MODE_OUTPUT,		//:_address.._mode = 1 -> Output with group connected
															39,								//:_address.._datatype -> Undefined type SIM
															"SIM",							//:_address.._drv_ident
															TRUE							//:_address.._active
);


const dyn_anytype FWBM_S7_CONFIG_VALUE = makeDynAnytype(	DPCONFIG_DISTRIBUTION_INFO,		//:_distrib.._type = 56 -> Driver allocation									
															FWBM_MANAGERID_S7,				//:_distrib.._driver = 2 -> Driver manager connected
															DPCONFIG_PERIPH_ADDR_MAIN,		//:_address.._type = 16 -> General peripheral address
															"AG45.",						//:_address.._reference -> Reference's name
															0,								//:_address.._subindex
															DPATTR_ADDR_MODE_INPUT_SPONT,	//:_address.._mode = 2 -> Input for spontaneous data
															702,							//:_address.._datatype -> S7 32-Bit Integer signed
															"S7",							//:_address.._drv_ident
															TRUE							//:_address.._active
);

const dyn_anytype FWBM_MOD_CONFIG_VALUE = makeDynAnytype(	DPCONFIG_DISTRIBUTION_INFO,		//:_distrib.._type = 56 -> Driver allocation									
															FWBM_MANAGERID_MODBUS,			//:_distrib.._driver = 3 -> Driver manager connected
															DPCONFIG_PERIPH_ADDR_MAIN,		//:_address.._type = 16 -> General peripheral address
															"M.",							//:_address.._reference -> Reference's name
															0,								//:_address.._subindex
															DPATTR_ADDR_MODE_OUTPUT,		//:_address.._mode = 1 -> Output with group connected
															560,							//:_address.._datatype -> Undefined type Modbus
															"MODBUS",						//:_address.._drv_ident
															TRUE							//:_address.._active
);

const dyn_anytype FWBM_IEC_CONFIG_VALUE = makeDynAnytype(	DPCONFIG_DISTRIBUTION_INFO,		//:_distrib.._type = 56 -> Driver allocation									
															FWBM_MANAGERID_IEC,				//:_distrib.._driver = 4 -> Driver manager connected
															DPCONFIG_PERIPH_ADDR_MAIN,		//:_address.._type = 16 -> General peripheral address
															"IECTARGET-",					//:_address.._reference -> Reference's name
															0,								//:_address.._subindex
															DPATTR_ADDR_MODE_INPUT_SPONT,	//:_address.._mode = 1 -> Input for spontaneous data
															522,							//:_address.._datatype -> Double point information with quality descriptor - type IEC
															"IEC",							//:_address.._drv_ident
															TRUE							//:_address.._active
);

const dyn_anytype FWBM_ARCHIVE_CONFIG_VALUE = makeDynAnytype(	DPCONFIG_DB_ARCHIVEINFO,	//45->Archive settings
															  	DPCONFIG_SMOOTH_SIMPLE_MAIN,	//48 -> standard smoothing (value/time dependent smooth
															  	"_ValueArchive_6",	//_ValueArchive_6 (New Database configuration)
															  	TRUE		////Should variable in the archive be saved
);

const dyn_anytype FWBM_ALERTHDL_CONFIG_VALUE = makeDynAnytype(	DPCONFIG_ALERT_NONBINARYSIGNAL,	//":_alert_hdl.._type" = 13 -> Alert handling analogous values
																DPDETAIL_RANGETYPE_MINMAX,		//":_alert_hdl.1._type" = 4 -> MinMax alert range
																DPDETAIL_RANGETYPE_MINMAX,		//":_alert_hdl.2._type"= 4 -> MinMax alert range
																
																273,							//":_alert_hdl.1._u_limit",
																273,							//":_alert_hdl.2._l_limit",
																
																FALSE,							//":_alert_hdl.1._u_incl",
																TRUE,							//":_alert_hdl.1._l_incl",
																FALSE,							//":_alert_hdl.2._u_incl",
																TRUE,							//":_alert_hdl.2._l_incl",
																
																"OK",							//":_alert_hdl.1._text",
																"DANGER",						//":_alert_hdl.2._text",
																
																"danger.",						//":_alert_hdl.2._class" 	DPT: _AlertClass, DPE: danger, warning, information
																TRUE,							//":_alert_hdl.._orig_hdl",
																TRUE							//":_alert_hdl.._active"														
);
