@echo off

::####################################################################
::This script aims at monitoring                                     #
::the cpu and shared memory usage of the                             #
::processes given as parameters.                                     #
::The monitoring stops when the                                      #
::'termination file' exists                                          #
:: Usage:                                                            #
:: fwBenchmark_MonitorResources $report_file $stop_file $executable1 #
::####################################################################

set REPORT_FILE=%1
set STOP_FILE=%2
set MANAGER_NAME=%3

:: make sure the report file is clean and the stop file does not exist
rm -f %REPORT_FILE%
rm -f %STOP_FILE%

echo Staring script fwBenchmark_MonitorResources.bat
echo to get the monitor resources of the process %MANAGER_NAME%.
echo The resources will be saved in the temporal file
echo %REPORT_FILE%
echo and this script will stop when the termination file exists:
echo %STOP_FILE%
echo This file will be created when the benchmark is finished.

:: while stop file does not exist,
:: get the metric and put them to a file
:whileloop
if NOT EXIST %STOP_FILE% (
	typeperf "\Process(%MANAGER_NAME%)\%% Processor Time" "\Process(%MANAGER_NAME%)\Private Bytes" -si 1 -sc 1|grep "/"| awk -F "," "{print $2 ""\t"" $3}"  >> %REPORT_FILE%
	::timeout /t 1 /nobreak > NUL	::it doesn't work
	ping 127.0.0.1 -n 2 -w 1000 > NUL
	goto whileloop
)

echo Script completed successfully
ping 127.0.0.1 -n 2 -w 1000 > NUL

::List the processor time of %MANAGER_NAME% process, take -si intervals (seconds) and -sc samples
::Only the line of the date has slash character (filter by grep command). We want the second column (separated with ,) of this line
::typeperf "\Process(%MANAGER_NAME%)\%% Processor Time" -si 1 -sc 1|grep "/"| awk -F "," "{print $2}"  >> %REPORT_FILE%
::We can comparate the $2 result with the %cpu usage in the task manager if we multiple $2 * the number of cores (4)

::Antoher possibility with tasklist command =
::tasklist /v /fo csv /nh /FI "imagename eq %MANAGER_NAME%.exe" | awk -F "," "{print $9 ""\t"" $5,$6}"  >> %REPORT_FILE%
::Antoher command with more information: wmic command (wmic process where Name="WCCILevent.exe" > test.txt)

echo End
exit
